<?php
include_once '.config/path.php';
machineBasedContent($machine);
$stOutput='';
$enableTwoStep  = '';
$showTwoStepDiv = "hideData";
$nasVerification='';

$isOpenBaseDirEnabled = FALSE;
$js_version = trim(preg_replace('/[a-zA-Z]+/', '', $appVersion));


if(!empty($_POST)) { 
	
	$needToLogout = "$appPath/logout.txt";
	@unlink($needToLogout);
	
	# check for app update in progress
	if(!clearAppUpdateLock()) {
		$stOutput 		= APP_UPDATE_IN_PROGRESS;
		$invalidUser	= true;
	} else {
		$invalidUser		= false;
		$nasUserName		= $_POST['nasUserName'];
		$nasPassword		= rawurldecode($_POST['nasPasswordHidden']);
		$nasVerification 	= isset($_POST['nasVerification'])? $_POST['nasVerification'] : '';
		
		getProxyDetail(); //Reading & assigning proxy details to session

		if($_SESSION['bypass_enabled'] == 'yes' && $machine == SYNOLOGY_LOCAL) {
			clearSessionProxySettings();
		}
		
		$stOutput = nasLogin($nasUserName,$nasPassword,$nasVerification);
		if($machine == SYNOLOGY_LOCAL) {
			getProxyDetail(); //Reading & assigning proxy details to session
		}

		if(strstr($stOutput, "TRUE") === "TRUE") {
			if(($machine == QNAP || $machine == SYNOLOGY_LOCAL || $machine == ASUSTOR ) && !isValidNASUser($nasUserName)) {
				# As NAS username is case sensitive, we need to verify NAS username's case.
				$realNASUser = getValidNASUser($nasUserName);

				$nasUserName = (($realNASUser != FALSE)? $realNASUser : $nasUserName);
				$_SESSION['nasUserName'] = $_POST['nasUserName'] = $nasUserName;
			}			
			$_SESSION['validUser'] = true;
			if(isset($_POST['remember'])) {
				setcookie("user", $_POST['nasUserName']);
				
				$keyIndex = rand(1,1000);
				$_SESSION['encryptionFlag'] = checkMcryptDecryptWorks(rawurldecode($_POST['nasPasswordHidden']),$keyIndex);
				$encryptedTokenVal = simple_encrypt(rawurldecode($_POST['nasPasswordHidden']),$keyIndex);
				setcookie("pass", $encryptedTokenVal);
				//setcookie("pass", getEncrypted(base64_decode($_POST['nasPassword']), $staticString['128'], $staticString['256']));
				setcookie("rememberMe", $_POST['remember']);
			} else {
				if(isset($_COOKIE['rememberMe'])) {
					setcookie("rememberMe", "");	
					setcookie("user", "");
					setcookie("pass", "");
				}
			}
			#need to check /etc/passwd file info for logged in user.
			$nasUserShellPerm = hasNASUserShellPermission();
			if($nasUserShellPerm === FALSE) {
				$stOutput 		= "NAS User Does Not Have Enough Permission";
				$msg = "Access <b>/etc/passwd</b> file, change <b>/sbin/nologin</b> to <b>/bin/sh</b> for <b>".$_SESSION['nasUserName']."</b> user and try again.";
				echo getDirPermissionHTML($stOutput, $msg);
				$invalidUser	= true;
			}else {
			
				$itemName = phpRealEscapeString($_SESSION['webDir']);	
				file_put_contents($temp_file, ISREADABLE."\n$itemName");
				@chmod($temp_file,$permissionVal);
				$iswritable = phpScriptExecution(OPERATIONSFILE, Scheduler::$service_dir.USER_PROFILE."/", 1);
				if($iswritable != "readable"){
					$stOutput 		= "NAS User Does Not Have Enough Permission";
					//$msg = "<b>Web</b> directory needs read permission for <b>".$_SESSION['nasUserName']."</b> user to continue.";
					$msg = "Please provide read permissions on <b>Web</b> directory for <b>".$_SESSION['nasUserName']."</b> user to continue.";
				
					echo getDirPermissionHTML($stOutput, $msg);
					//$stOutput 		= "Web directory needs at-least read permission to continue.";
					$invalidUser	= true;
				}else{		
					$stDestinationURL = ".config/";
					header("Location:$stDestinationURL");
					exit();
				}
			}
		} else if($stOutput=="FALSE") {
			$stOutput 		= INVALID_NAS_LOGIN;
			$invalidUser	= true;
		} else {
			if($machine == SYNOLOGY_LOCAL || $machine == QNAP || $machine == ASUSTOR ) {
				if($stOutput == BLOCKED_IP){
					$stOutput = "Your IP has been blocked. Please remove it from block list.";		
				} else if(!strstr($stOutput,INVALID_NAS_LOGIN) && !strstr($stOutput,INVALID_HOST_NAME) && !strstr($stOutput,INVALID_PROXY)){
					$showTwoStepDiv = "showData";
					$enableTwoStep = "class='label_checked'";
					$nasVerification = '';
				} else {
					$nasPassword = '';
				}
				if($machine == SYNOLOGY_LOCAL && trim($stOutput) == INVALID_HOST_NAME && !isOpenBaseDirValid()) {
					# Validate for open_basedir -> /etc:
					$stOutput = str_replace('{:PRE_REQUISITE_URL:}', SYNOLOGY_PREREQUISITES_URL, PHP_OPENBASE_DIR_MESSAGE);
					$isOpenBaseDirEnabled = TRUE;
				}				
			} else {
				$stOutput = INVALID_NAS_LOGIN;
			}
			
			$invalidUser = true;
		}
		# added this to dynamically display error message based on machine name.
		if($stOutput == INVALID_NAS_LOGIN){
			$machinePattern = getMachinePattern();
			$machine = $machinePattern[1];
			$msg = "Invalid ".ucfirst($machine)." username or Password";
			$stOutput = $msg;
		}
	}
} else {
	if(isset($_SESSION['validUser']) && ($_SESSION['validUser'] === true)) {
		exit(header("Location:.config/index.php"));
	}else{
		$needToLogout = "$appPath/logout.txt";
		@unlink($needToLogout);
	}
}
?>
<!doctype html>
<html>
<head>
    <meta charset="UTF-8">
    <title><?php print $appMetaTitle;?></title>
    <link href=".config/include/css/qnap_layout.css?ver=<?php echo $js_version;?>" type="text/css" rel="stylesheet" />
    <link href=".config/include/css/<?php print $appThemeCSS;?>?ver=<?php echo $js_version;?>" type="text/css" rel="stylesheet" />
	<!--[if IE 8]>  <link href=".config/include/css/ie8.css?ver=<?php echo $js_version;?>" rel="stylesheet" type="text/css" /> <![endif]-->
		<!--[if lte IE 7]>  <link href=".config/include/css/ie7.css?ver=<?php echo $js_version;?>" rel="stylesheet" type="text/css" /> <![endif]-->
		<!--[if IE]> <script src="https://html5shim.googlecode.com/svn/trunk/html5.js"></script> <![endif]-->
    <link rel="icon" href=".config/include/images/<?php print $appFavicon;?>" sizes="16x16" />
    <link rel="shortcut icon" href=".config/include/images/<?php print $appFavicon;?>" type="image/x-icon" />
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js" type="text/javascript"></script>
    <script src=".config/include/scripts/popupScript.js?ver=<?php echo $js_version;?>" type="text/javascript"> </script>
</head>
<body class="login-con">
    <section class="body login_body">
        <div class="wrapper">
		<?php if($machine=='twotier'){ ?>
		<header>
            <h1>
				<a class="vault_logo" target="_blank" href="https://www.idrive.com/">Online Backup for PC, Mac and iPhone | IDrive</a>
				<p class="version"><span class="version-no"><?php print $appVersion;?></span>
				<?php		
					if(trim($checkUpdate)=='Y') {
				?>
					<span class="update-btn" title="<?php print $appUpdateMsg; ?>"><a  href="<?php print $appUpdateURL; ?>" target="_blank"></a></span>
				<?php }	?>
				
				</p>
			</h1>          
         </header>
		<?php }	?> 
        <section class="login_cont">
			<?php if($isOpenBaseDirEnabled) { ?>
				<div class="noshell_msg" style="margin-bottom: 20px;">
					<div class="popup_container">
						<section class="popup_header">
							<h4>Pre-requisites is not met</h4>
							<span class="popup_close_btn hide_popup"></span>
						</section>
						<span class="nas_warning"><?=$stOutput;?></span>
					</div>
				</div>
			<?php } ?>		
			<div class="brand_img">					
				<h2><?php print $appTitle;?></h2>
				<p><?php print $appDesc;?></p>
				<img src=".config/include/images/<?php print $appCloudPath;?>">
			</div>
			<!--<div class="login-divider"></div>-->
			<div class="login_details">
			<?php if(!$isOpenBaseDirEnabled) { ?>
				<div class="common_msg error_msg controls">
				 <p class="info-label" id="errorMsg"><?php print $stOutput; ?></p>
				 <a href="#" class="close_info"><img width="16" height="16" title="Close" alt="close" src=".config/include/images/close.png"></a>
			   </div>
			<?php } ?>	
				<div class="login_head"> <span>Authenticate your <?php print $appName;?> device</span> </div>			
				<form action="index.php" id="loginForm" name="login" method="post" onSubmit="return validate_form()" accept-charset="UTF-8">
					<div class="uname">
						<label>Username</label>
						<?php
							if(!empty($nasUserName)){
								$attr = ' value="'.htmlentities($nasUserName,ENT_QUOTES).'" ';
							} else if(isset($_COOKIE['user'])){
								$attr = ' value="'.htmlentities($_COOKIE['user'],ENT_QUOTES).'" ';		
							} else {
								$attr = ' value="" ';
							}							
						?>
						<input type="text" class="input" id="nasUserName" placeholder="<?php print $appName;?> device username" name="nasUserName" tabindex="1"	<?php print $attr; ?> >
					</div>
					<div class="pwd">
						<?php	
						$passValue ='';
						if(!empty($nasPassword)){
							$passValue = htmlentities($nasPassword,ENT_QUOTES);
						} else if(isset($_COOKIE['pass'])){
							//$passValue = htmlentities(getDecrypted($_COOKIE['pass'], $staticString['128'], $staticString['256']),ENT_QUOTES);
							GLOBAL $appPath ;
							$phpPath     = getPhpPath();
							$keyIndex = rand(1,1000);
							$_SESSION['encryptionFlag'] = checkMcryptDecryptWorks($_COOKIE['pass'],$keyIndex);
							
							$command 	 = "$phpPath $appPath/.config/token.php ".$_COOKIE['pass'] ." ".$_SESSION['encryptionFlag'];
							$passValue	= shell_exec($command);	
						}
						?>	
						<label>Password</label>
						<input type="password" class="input" id="nasPassword" name="nasPassword" tabindex="2" placeholder="<?php print $appName;?> device password" value="<?php print $passValue; ?>">							
						<input type="hidden" id="nasPasswordHidden" name="nasPasswordHidden" value="<?php print $passValue; ?>">
					</div>
					<div class="control-group">
					<label class="control-label"></label> 						
					</div>
					<?php 
					if($machine!=SYNOLOGY_LOCAL) {?>
					<div class="remem_box">							
						<input type="checkbox" name="remember" id="remember" tabindex="3" 
						<?php
						if(isset($_COOKIE['rememberMe'])){
							print "checked='yes'";
						}
						?>><span>Remember me</span>
					</div>
					<?php } 
					if($machine==SYNOLOGY_LOCAL || $machine==QNAP || $machine==ASUSTOR){?>
					<div class="remem_box enable <?php print $showTwoStepDiv;?>">
						<span class="file_check span-common"><input type="checkbox" tabindex="4" name="remember">
							<label id="enable" <?php print $enableTwoStep; ?>> files </label>
						</span> <span class="span-common pad-left">&nbsp;Have 2-step verification?</span> <span class="qnap-lock"></span> 
					</div>
					<div id="verficationText" class="remem_box enable brd-top <?php print $showTwoStepDiv;?>">
						<label class="Diti">Enter 6-digit code</label>                
						<input type="text" name="nasVerification" tabindex="5" class="code" maxlength="6" value="<?php print $nasVerification; ?>">
					</div>						
					<?php 
					}
					?>
					<div>
						<input name="Submit" type="submit" class="login_btn" value="Login" tabindex="4" style="display:none;">
						<img width="" height="" border="0" src=".config/include/images/qnap_login_dis.png" class="disable_img">
					</div>
				</form>
			</div>
		</section>
        <footer>&copy; IDrive Inc.</footer>
      </div>
    </section>
</body>
</html>


<SCRIPT LANGUAGE="JavaScript">
jQuery('input.login_btn').show();
jQuery('img.disable_img').hide();
var enteredUserNameField = false;
var enteredPasswordField = false;

var validUserName = false;
var validPassword = false;

var valid2stepCode = false;

/****************************************************************************************************
Subroutine Name         : set_user_name_status.
Objective               : Sets User name status as true if it is not empty. 
Added By                : Arnab Gupta.
*****************************************************************************************************/
function set_user_name_status()
{ 
  enteredUserNameField = true;
}

/****************************************************************************************************
Subroutine Name         : set_password_status.
Objective               : Sets Password status as true if it is not empty. 
Added By                : Arnab Gupta.
*****************************************************************************************************/
function set_password_status()
{ 
  enteredPasswordField = true;
}

/****************************************************************************************************
Subroutine Name         : validate_user_name.
Objective               : Validates User name and throws warning messages on screen if User name 
contains only spaces or just empty. 
Added By                : Arnab Gupta.
*****************************************************************************************************/
function validate_user_name()
{ 
  if(enteredUserNameField)
  {
    validUserName = false;

    var userIdElement="nasUserName";
    var userNameElement = document.getElementById(userIdElement);

    if(userNameElement.value != "")
    {
      var strUserName = userNameElement.value;
      strUserName = strUserName.replace(/\s+/g, "");
       
      if(strUserName == "")
      {
        var errorMsgStr = "Username field contains only whitespaces";

        var errorMsgElement = document.getElementById("errorMsg");
        //errorMsgElement.innerHTML = errorMsgStr.fontcolor("RED");
		errorMsgElement.innerHTML = errorMsgStr;
		
        userNameElement.value = "";
        setTimeout(function(){userNameElement.focus()}, 100);
      }
      else
      {
        var errorMsgStr = ".";

        var errorMsgElement = document.getElementById("errorMsg");
        //errorMsgElement.innerHTML = errorMsgStr.fontcolor("WHITE");
		errorMsgElement.innerHTML = errorMsgStr;

        validUserName = true;

        var passwordIdElement="nasPassword";

        var passwordElement = document.getElementById(passwordIdElement);
        setTimeout(function(){passwordElement.focus()}, 100);
      }
    }
    else
    { 
      var errorMsgStr = "Username field is empty";

      var errorMsgElement = document.getElementById("errorMsg");
      //errorMsgElement.innerHTML = errorMsgStr.fontcolor("RED");
	  errorMsgElement.innerHTML = errorMsgStr;

      setTimeout(function(){userNameElement.focus()}, 100);  
    }
  }
}

/****************************************************************************************************
Subroutine Name         : validate_password.
Objective               : Validates nasPassword and throws warning messages on screen if pasword 
contains only spaces or just empty. 
Added By                : Arnab Gupta.
*****************************************************************************************************/
function validate_password()
{
  if(validUserName && enteredPasswordField)
  {
    validPassword = false;

    var passwordIdElement="nasPassword";
    var passwordElement = document.getElementById(passwordIdElement);

    if(passwordElement.value != "")
    {
      var strPassword = passwordElement.value;
      strPassword = strPassword.replace(/\s+/g, "");
       
      if(strPassword == "")
      {
        var errorMsgStr = "Password field contains only whitespaces";

        var errorMsgElement = document.getElementById("errorMsg");
        //errorMsgElement.innerHTML = errorMsgStr.fontcolor("RED");
		errorMsgElement.innerHTML = errorMsgStr;

        passwordElement.value = "";
        setTimeout(function(){passwordElement.focus()}, 100);
      }
      else
      {
        var errorMsgStr = ".";

        var errorMsgElement = document.getElementById("errorMsg");
        //errorMsgElement.innerHTML = errorMsgStr.fontcolor("WHITE");
		errorMsgElement.innerHTML = errorMsgStr;

        validPassword = true;
      }
    }
    else
    {
      var errorMsgStr = "Password field is empty";

      var errorMsgElement = document.getElementById("errorMsg");
      //errorMsgElement.innerHTML = errorMsgStr.fontcolor("RED");
	  errorMsgElement.innerHTML = errorMsgStr;

      setTimeout(function(){passwordElement.focus()}, 100);  
    }
  }
}

function validate2stepCode(){
	if($("#verficationText").is(":visible")){
		var nasVerificationElement = jQuery('input[name="nasVerification"]');
		var nasVerification = nasVerificationElement.val().trim();
		if(nasVerification=='' || isNaN(nasVerification) || nasVerification.length!=6){
			var errorMsgStr = "Verification code should contain 6 digit";
			var errorMsgElement = document.getElementById("errorMsg");
			//errorMsgElement.innerHTML = errorMsgStr.fontcolor("RED");
			errorMsgElement.innerHTML = errorMsgStr;

			setTimeout(function(){nasVerificationElement.focus()}, 100);			
		} else {
			valid2stepCode = true;
		}
	} else
		valid2stepCode = true;
}
/****************************************************************************************************
Subroutine Name         : validate_form.
Objective               : Validates all components of form such as User name and password. 
Added By                : Arnab Gupta.
*****************************************************************************************************/
function validate_form() 
{ 
	jQuery('.error_msg').hide();
	set_user_name_status();
	validate_user_name();

	set_password_status();
	validate_password();
	validate2stepCode();
  
	if(validUserName && validPassword && valid2stepCode) {
		jQuery('.error_msg').hide();
		jQuery('#nasPasswordHidden').val(rawurlencode(jQuery('#nasPassword').val()));
		return true;
	} else {
		jQuery('.error_msg').show();
		return false;
	}
}

function rawurlencode(str) {
  str = (str + '').toString();
  return encodeURIComponent(str)
    .replace(/\~/g, '%7E')
    .replace(/!/g, '%21')
    .replace(/'/g, '%27')
    .replace(/\(/g, '%28')
    .replace(/\)/g, '%29')
	.replace(/\*/g, '%2A');
}

function rawurldecode(str) {
      return decodeURIComponent( (str + '')
	  .replace( /\%21/g, '!' )
	  .replace( /\%27/g, "'" )
	  .replace( /\%28/g, '(' )
	  .replace( /\%29/g, ')' )
	  .replace( /\%2A/g, '*' )
	  .replace( /\%7E/g, '~' ) );
}

function base64_encode(data, urlSafe) {
	if(urlSafe)
		var b64 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_:';
	else
		var b64 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';

	var o1, o2, o3, h1, h2, h3, h4, bits, i = 0,
    ac = 0,
    enc = '',
    tmp_arr = [];

	if (!data) {
		return data;
	}

	do { // pack three octets into four hexets
		o1 = data.charCodeAt(i++);
		o2 = data.charCodeAt(i++);
		o3 = data.charCodeAt(i++);

		bits = o1 << 16 | o2 << 8 | o3;

		h1 = bits >> 18 & 0x3f;
		h2 = bits >> 12 & 0x3f;
		h3 = bits >> 6 & 0x3f;
		h4 = bits & 0x3f;

		// use hexets to index into b64, and append result to encoded string
		tmp_arr[ac++] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
	} while (i < data.length);

	enc = tmp_arr.join('');
	var r = data.length % 3;
	return (r ? enc.slice(0, r - 3) : enc) + '==='.slice(r || 3);
}

$(document).ready(function() {
	//$('#verficationText').hide();
	<?php
		if ($machine == 'twotier') print("$('.update-btn').hide();");
	?>
	$('#enable').click(function(){
		$("#verficationText").slideToggle();
		$("input.code").val('');
	});
	$('#verficationText').css({"font-size":"14px", "margin-top":"0px"});
	if($("#verficationText").is(":visible")){ $("input.code").focus();}
	
	//Allowing to enter numbers only for 2-Step verification
	jQuery('#verficationText input').die('keypress').live('keypress',function(event){
		var keyCode = event.charCode;
		if (keyCode == undefined)
			keyCode = event.keyCode;
		
		if (keyCode != 0 && !(keyCode >= 48 && keyCode <= 57))
		{	
			event.preventDefault();
			//showErrorMessages('#popupError1','You can use letters, numbers, space and characters(.-_)');
		}    	
	});	
	
});
<?php
if(isset($invalidUser) && $invalidUser)
{
	?>	
//jQuery('#errorMsg').html('User Name or Password is Invalid');
jQuery('.error_msg').show();	
<?php
}
?>

(function($) {
	$(document).ready(function() {
		$('.popup_close_btn').on('click', function() {
			$('.noshell_msg').hide();
		});
	});
})(jQuery);
</SCRIPT>

<noscript>

	<DIV CLASS="controls">
		<LABEL CLASS="info-label">
			<p> 
				<P CLASS="text-error">
					<div style="width:1000px;">
  <h2 style="text-align:center"> <font color="red">Please enable JavaScript option for the app to work fine </font></h2>  
					</div>
				</P>
			</p>
		</LABEL>
	</DIV>
</noscript>
<?php
//print $sesionId = session_id();
//$sessionUserExpirePath = (session_save_path() . "/sess_" . $sesionId);
//unlink($sessionUserExpirePath);
session_destroy(); //Added for first moment
?>
